<?php

static $leaderboard_fname = "reports/poker.csv";
static $points_fname = "reports/points.csv";
static $events_fname = "reports/events.csv";
static $last_events_fname = "reports/last_events.csv";
static $announcements_fname = "reports/announcements.csv";
static $schedule_fname = "reports/schedule.csv";
static $sponsors_fname = "reports/sponsors.csv";
static $tournaments_fname = "reports/tournaments.csv";
static $quarterly_fname = "reports/quarterly.csv";

static $old_leaderboard_fname = "reports/oldpoker.csv";
static $old_points_fname = "reports/oldpoints.csv";
static $old_events_fname = "reports/oldevents.csv";

$end_of_last_season = "END_OF_LAST_SEASON";
$trans_type_collected = 1;
$trans_type_owed      = 2;
$trans_type_expense   = 3;

function getsqli_result($result, $row, $field=0)
{
	$result->data_seek($row);
	$datarow = $result->fetch_array();
	return $datarow[$field];
}

function leaderboard_table($fname)
{
	echo "
		<h4>Leaderboard</h4>
 			<div class='table_box'>
  			<table id='players' border='0'>
        	<tr>
          		<td><strong>Player</strong></td>
          		<td><strong>Points</strong></td>
        	</tr>
			";

	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$pair = explode(",",$line);
			echo "
				<tr>
					<td>$pair[0]</td>
					<td>$pair[1]</td>
				</tr>
				";
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}

	echo "
		</table></div>
		";
}

function generate_leaderboard_file($fname)
{
/*	include 'login.php';

	$db_server = mysql_connect($db_hostname,$db_username,$db_password);
	if ($db_server)
	{
		if (mysql_select_db($db_database))
		{
*/
	global $db_connect;

			$query = "SELECT player_name,sum(num_points) from players,points where players.player_id = points.player_id
			group by player_name order by sum(num_points) DESC, player_name ASC";
			if ($result = mysqli_query($db_connect, $query))
			{
				$rows = mysqli_num_rows($result);
				
				$tmp_fname = $fname . ".tmp";
				
				if ($fh = fopen($tmp_fname,'w'))
				{
					for ($j = 0 ; $j < $rows ; ++$j)
					{
						$row = mysqli_fetch_row($result);
						$line = $row[0] . ',' . $row[1] . "\n";
						fwrite($fh,$line);
					}
					fclose($fh);
					rename($tmp_fname,$fname);
				}	
			}
/*
		}
		mysql_close($db_server);
	}
*/
}

function generate_table($fname, $column_names, $table_id = "generic_table" )
{
	echo "
		<div class='table_box' border='0'>
		";

	echo "<table id='$table_id' border='1'>";
	echo "<tr>";
	foreach ($column_names as $name)
	{
		echo "<td><strong>$name</strong></td>";
	}
	echo "</tr>
	";

	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$row = explode(",",$line);
			echo "<tr>";
			foreach ($row as $index => $value)
			{
				echo "<td>$value</td>";
			}
			echo "</tr>
			";
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}

	echo "
		</table></div><br />
		";
}

function generate_table_with_fast_index ($fname, $column_names)
{
	echo "
		<div>
		";
	echo "
		<div class='table_box' border='0'>
		";

	echo "<table id='generic_table' border='1'>";
	echo "<tr>";
	foreach ($column_names as $name)
	{
		echo "<td><strong>$name</strong></td>";
	}
	echo "</tr>
	";

	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$row = explode(",",$line);
			echo "<tr>";
			foreach ($row as $index => $value)
			{
				echo "<td>$value</td>";
			}
			echo "</tr>
			";
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}

	echo "
		</table></div><br />
		";
}
function generate_schedule_table($fname, $full)
{
	echo "
		<div class='table_box' border='0'>
		";

	if ($full)
	{
		echo "<table id='schedule'  width='580' border='1'>
		      <tr>
				<th width='107' scope='col'><strong>Day</strong></th>
				<th width='119' scope='col'><strong>Venue</strong></th>
				<th width='240' scope='col'><strong>Location</strong></th>
				<th width='87'  scope='col'><strong>Time</strong></th>
			  </tr>";
	}
	else
	{
		echo "<table id='schedule'  width='450' border='1'>
		      <tr>
				<th width='40'  scope='col'><strong>Day</strong></th>
				<th width='100' scope='col'><strong>Venue</strong></th>
				<th width='160' scope='col'><strong>City</strong></th>
				<th width='80'  scope='col'><strong>Time</strong></th>
			  </tr>";
	}

	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$row = explode(",",$line);
			$day = $row[0];
			$venue = $row[1];
			$street = $row[2];
			$city = $row[3];
			$state = $row[4];
			$phone = $row[5];
			$website = $row[6];
			$time = $row[7];
			
			echo "<tr>";
			echo "<td>$day</td>";

			if ($website != "")
			{
				echo "<td><a href = '$website' >$venue</a>";
			}
			else
			{
				echo "<td>$venue</td>";
			}
			
			if ($full)
			{
				echo "<td>$street<br />$city, $state<br />$phone</td>";
			}
			else
			{			
				echo "<td>$city, $state</td>";
			}
			echo "<td>$time</td>";
			echo "</tr>
			";
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}

	echo "
		</table></div><br />
		";
}

function generate_sponsors_table($fname)
{
	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$line = trim($line);
			$row = explode(",",$line);
			$sponsor = $row[0];
			$website = $row[1];
			$image = $row[2];

			if ($image != "")
			{
				$image =  "<img src=\"$image\" alt=\"$sponsor\" width=\"100%\" />";
				$sponsor = "";
			}
		
			if ($website != "")
			{
				echo "<p><a href = \"$website\" >$sponsor$image</a></p>";
			}
			else
			{
				echo "<p>$sponsor$image</p>";
			}
			
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}
}

function generate_tournaments_table($fname)
{
	echo "
		<div class='table_box' border='0'>
		";

	echo "<table id='tournament' border='1'>
	      <tr>
			<th width='100' scope='col'><strong>Date</strong></th>
			<th width='140' scope='col'><strong>Location</strong></th>
			<th scope='col'><strong>Details</strong></th>
		  </tr>";

	if ($fh = fopen($fname, 'r'))
	{
		while ($line = fgets($fh))
		{
			$row = explode(",",$line);
			$venue = $row[0];
			$street = $row[1];
			$city = $row[2];
			$state = $row[3];
			$phone = $row[4];
			$website = $row[5];
			$date = $row[6];
			$time = $row[7];
			$details = $row[8];
			
			echo "<tr>";
			echo "<td>$date<br />$time</td>";

			if ($website != "")
			{
				echo "<td><a href = '$website' >$venue</a>";
			}
			else
			{
				echo "<td>$venue";
			}
			
			echo "<br />$street<br />$city, $state<br />$phone</td>";
			echo "<td align='center'>$details</td>";
			echo "</tr>
			";
		}
		fclose($fh);
	}
	else
	{
		echo "$fname not found";
	}

	echo "
		</table></div><br />
		";
}

function generate_file ($result, $fname)
{
	$rows = mysqli_num_rows($result);
				
	$tmp_fname = $fname . ".tmp";
				
	if ($fh = fopen($tmp_fname,'w'))
	{
		for ($j = 0 ; $j < $rows ; ++$j)
		{
			$row = mysqli_fetch_row($result);
			$line = '';
			$first = 1;
			foreach ($row as $value)
			{
				if (!$first)
				{
					$line .= ',';
				}
				else
				{
					$first = 0;
				}
				$line .= str_replace(","," ",$value);
			}
			$line .= "\n";
			fwrite($fh,$line);
		}
		fclose($fh);
		rename($tmp_fname,$fname);
	}	
}

function dump_result ($result, $column_names)
{
	echo "
 		<div class='table_box'>
  		<table id='result' border='1'>
		<tr>";
		
	foreach ($column_names as $name)
	{
		echo "<td><strong>$name</strong></td>";
	}
	echo "</tr>";

 	$rows = mysqli_num_rows($result);
				
	for ($j = 0 ; $j < $rows ; ++$j)
	{
		$row = mysqli_fetch_row($result);
		foreach ($row as $index => $value)
		{
			echo "<td>$value</td>";
		}
		echo "</tr>";
	}
	echo "</table></div><br />";
}

function get_location($location_id)
{
	global $db_connect;
	
	$location = "";
	$query = "SELECT location FROM locations where location_id = '$location_id'";
	$result = mysqli_query($db_connect, $query);
	if ($result)
	{
		$location = getsqli_result($result,0,'location');
	}
	return $location;
}

function location_select ($label)
{
	global $db_connect;

	echo "<br />$label <select name=\"location_id\" size=\"1\">";
	$query = "SELECT location,location_id FROM locations ORDER BY location";
	$result = mysqli_query($db_connect, $query);
	if ($result)
	{
		$rows = mysqli_num_rows($result);
		for ($j = 0 ; $j < $rows ; ++$j)
		{
			$location = getsqli_result($result,$j,'location');
			$location_id = getsqli_result($result,$j,'location_id');
			echo "<option value=$location_id>$location</option>";
		}
	}
	echo "</select><br />";
}

function location_select_default ($label, $default)
{	
	global $db_connect;
	
	echo "<br />$label <select name=\"location_id\" size=\"1\">";
	$query = "SELECT location,location_id FROM locations ORDER BY location";
	$result = mysqli_query($db_connect, $query);
	if ($result)
	{
		$rows = mysqli_num_rows($result);
		for ($j = 0 ; $j < $rows ; ++$j)
		{
			$location = getsqli_result($result,$j,'location');
			$location_id = getsqli_result($result,$j,'location_id');
			if ($default == $location_id)
			{
				echo "<option selected='selected' value=$location_id>$location</option>";
			}
			else
			{
				echo "<option value=$location_id>$location</option>";
			}
		}
	}
	echo "</select><br />";
}

function player_select ($label)
{
	global $db_connect;

	echo "<br />$label <select name=\"player_id\" size=\"1\">";
	$query = "SELECT player_name,player_id FROM players ORDER BY player_name";
	$result = mysqli_query($db_connect,$query);
	if ($result)
	{
		$rows = mysqli_num_rows($result);
		for ($j = 0 ; $j < $rows ; ++$j)
		{
			$player_name = getsqli_result($result,$j,'player_name');
			$player_id = getsqli_result($result,$j,'player_id');
			echo "<option value=$player_id>$player_name</option>";
		}
	}
	echo "</select><br />";
}

function id_select ($query, $label, $select_name)
{
	global $db_connect;

	echo "<br />$label <select name=\"$select_name\" size=\"1\">";
	$result = mysqli_query($db_connect,$query);
	if ($result)
	{
		$rows = mysqli_num_rows($result);
		for ($j = 0 ; $j < $rows ; ++$j)
		{
			$row = mysqli_fetch_row($result);
			echo "<option value=$row[0]>";
			$num_col = count($row);
			for ($i = 1 ; $i < $num_col; ++$i)
			{
				if ($i > 1) echo " ";
				echo "$row[$i]";
			}
			echo "</option>";
		}
	}
	echo "</select><br />";
}

function sanitizeString($somestring)
{
	$var = stripslashes($somestring);
	$var = htmlentities($var);
	$var = strip_tags($var);
	if ($var != $somestring) $var = '';
	return $var;
}

function sanitizeSql($somestring)
{
	global $db_connect;

	$var = mysqli_real_escape_string($db_connect,$somestring);
	$var = sanitizeString($var);
	if ($var != $somestring) $var = '';
	return $var;
}

function sanitizeSql2($somestring)
{
	global $db_connect;

	$var = mysqli_real_escape_string($db_connect,$somestring);
	$var = stripslashes($var);
	$var = htmlentities($var);
	$var = strip_tags($var);
	return $var;
}

function sanitizeSqlLeaveHtml($somestring)
{
	global $db_connect;

	$var = mysqli_real_escape_string($db_connect,$somestring);
	$var = stripslashes($var);
	return $var;
}

function var_value ($var_name)
{
	global $db_connect;

	$query = "SELECT var_svalue FROM vars WHERE var_name = \"$var_name\"";
	$result = mysqli_query($db_connect,$query);
	if (!$result or (mysqli_num_rows($result) == 0))
	{
		return "";
	}
	else
	{
		return getsqli_result($result,0,'var_svalue');
	}
}

function update_var_value($var_name, $var_svalue)
{
	global $db_connect;

	$query = "UPDATE vars SET var_svalue = \"$var_svalue\" where var_name = \"$var_name\"";
	$result = mysqli_query($db_connect, $query);
	if (!$result)
	{
		echo "Update failed <br />$query<br />" . mysqli_error($db_connect) . "<br />";
	}
	else if (mysqli_affected_rows($db_connect) == 0)
	{
		$query = "INSERT INTO vars (var_name, var_svalue) VALUES ('$var_name', '$var_svalue')";
		$result = mysqli_query($db_connect,$query);
		if (!$result)
		{
			echo "Update failed <br />$query<br />" . mysqli_error($db_connect) . "<br />";
		}
	}
	return $result;
}

function get_end_of_season()
{
	global $end_of_last_season;
	date_default_timezone_set('America/New_York');
	$endofseason = var_value($end_of_last_season);
	if ($endofseason < date("Y-m-d"))
	{
		return $endofseason;
	}
	else
	{
		return "";
	}
}



?>
